<?php declare(strict_types=1);

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Class Answer
 * @ORM\Entity
 * @ORM\Table(name="mls_answer")
 * @package App\Entity
 */
class Answer
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    protected int $id;

    /**
     * @ORM\Column(nullable=false)
     * @ORM\ManyToOne(fetch="EAGER", targetEntity="App\Entity\Question", inversedBy="answers")
     */
    protected Question $question;

    /** @ORM\Column(columnDefinition="VARCHAR(1024)", length=1024, nullable=false)  */
    protected string $label;

    /** @ORM\Column(columnDefinition="BOOL", name="is_correct", nullable=false)  */
    protected bool $correct = false;

    protected bool $transientCorrent;

    public function getQuestion() : Question
    {
        return $this->question;
    }

    public function getId() : ?int
    {
        return $this->id;
    }

    public function getLabel() : string
    {
        return $this->label;
    }

    public function setLabel(string $label) : self
    {
        $this->label = $label;
        return $this;
    }

    public function isCorrect() : bool
    {
        return $this->correct;
    }

    public function evaluate() : bool
    {
        return $this->transientCorrent === $this->correct;
    }

    public function setTransientCorrect(bool $transientCorrect) : self
    {
        $this->transientCorrent = $transientCorrect;
        return $this;
    }

    public function setCorrect(bool $correct) : self
    {
        $this->correct = $correct;
        return $this;
    }
}